local player = {}

function player:load()
	self:resize()
end

function player:reset()
	self.x = math.floor(screen.width * 0.3)
	self.y = (screen.height / 2) - (self.size / 2)
	self.yVel = 0
	self.bOverlap = false
	self.tOverlap = false

	self.alpha = 255
	self.dAlpha = 0
end

function player:resize()
	self.x = math.floor(screen.width * 0.3)
	self.y = screen.height * PLAYER_NORMAL_Y
	self.size = math.floor(screen.height * 0.05)
	self.flapHeight = screen.height * 0.7
end

function player:update(dt)
	self.dAlpha = self.dAlpha + (self.alpha  - self.dAlpha) * (SMOOTH_FACTOR * dt)
	if not game.paused and game.started and not game.lost then
		self.yVel = self.yVel + GRAVITY * dt

		local ny = self.y + self.yVel * dt

		--top
		if ny < 0 then
			self.tOverlap = true
			if ny < -self.size then
				self.tOverlap = false
				ny = screen.height - self.size
			end
		end

		if ny + self.size > screen.height then
			self.bOverlap = true
			if ny > screen.height then
				self.bOverlap = false
				ny = 0
			end
		end

		self.y = ny
	end
end

function player:draw()
	love.graphics.setColor(self.color)
	setAlpha(self.dAlpha)
	love.graphics.rectangle("fill", self.x, self.y, self.size, self.size)

	if self.bOverlap then
		love.graphics.rectangle("fill", self.x, self.y - screen.height, self.size, self.size)
	end

	if self.tOverlap then
		love.graphics.rectangle("fill", self.x, self.y + screen.height, self.size, self.size)
	end
end

function player:flap()
	if not game.lost then
		self.yVel = -self.flapHeight
	end
end

return player