local theme = {}

function theme:load()
	self.themes = {}
	local f = love.filesystem.getDirectoryItems("src/theme/themes")
	for i,v in ipairs(f) do
		local name = string.match(v, "%a+%.-")
		local ext = string.match(v, "%.+%a+")
		if ext == ".lua" then
			self.themes[name] = require("src/theme/themes/"..name)
		end
	end
end

function theme:apply(name)
	if self.themes[name] then
		local t = self.themes[name]
		game.backgroundColor = t.background
		player.color = t.player
		platform.color = t.platform
		game.textColor = t.textColor
		game.textColorAccent = t.textColorAccent
		game.coverColor = t.coverColor
		button.color = t.buttonColor
	end
end

return theme